import Vue from "vue";
// import "@/lib/spark-md5.min.js";
const SparkMD5 = require('spark-md5')
// import a form "@/lib/aa.js";
// console.log(aa);



// 缓存
const DicsCatch = {};
// 单级下拉字典项
Vue.prototype.$dicsListsInit = function (selectList) {

    return new Promise((resolve, reject) => {
        let noSelectList = {};
        for (let selectNames in selectList) {
            let dicsName = selectList[selectNames];
            if (!!DicsCatch[dicsName]) {
                this[selectNames] = DicsCatch[dicsName]
            } else {
                noSelectList[selectNames] = dicsName
            }
        }

        if (Object.values(noSelectList).length <= 0) {
            resolve()
        } else {
            this.$axios({
                method: "post",
                url: this.$api.common.getDictListsByTypes,
                data: {
                    dictTypes: Object.values(noSelectList).join(",")
                }
            }).then(res => {
                if (res.code != 200) {
                    this.$message.error(res.message || "字典获取失败");
                    reject();
                    return false;
                }
                let result = res.info;
                for (let selectNames in noSelectList) {
                    let dicsName = noSelectList[selectNames];
                    for (let i = 0; i < result[dicsName].length; i++) {
                        this[selectNames].push({
                            caption: result[dicsName][i].dictName,
                            code: result[dicsName][i].dictCode,
                        });
                    }
                    DicsCatch[dicsName] = this[selectNames]
                }
                resolve();
            }).catch(error => {
                this.$message.error("网络异常");
                reject(error);
            });
        }
    });
}



// 缓存
const DicsTreeCatch = {};
// 单级下拉字典项
Vue.prototype.$dicsTreesInit = function (selectList) {

    return new Promise((resolve, reject) => {
        let noSelectList = {};
        for (let selectNames in selectList) {
            let dicsName = selectList[selectNames];
            if (!!DicsTreeCatch[dicsName]) {
                this[selectNames] = DicsTreeCatch[dicsName]
            } else {
                noSelectList[selectNames] = dicsName
            }
        }

        if (Object.values(noSelectList).length <= 0) {
            resolve()
        } else {
            this.$axios({
                method: "post",
                url: this.$api.common.getDictTreesByTypes,
                data: {
                    dictTypes: Object.values(noSelectList).join(",")
                }
            }).then(res => {
                if (res.code != 200) {
                    this.$message.error(res.message || "字典获取失败");
                    reject();
                    return false;
                }
                let result = res.info;
                for (let selectNames in noSelectList) {
                    let dicsName = noSelectList[selectNames];
                    // for (let i = 0; i < result[dicsName].length; i++) {
                    //     this[selectNames].push({
                    //         name: result[dicsName][i].dictName,
                    //         code: result[dicsName][i].dictCode,
                    //     });
                    // }
                    this[selectNames] = result[dicsName]
                    DicsTreeCatch[dicsName] = this[selectNames]
                }
                resolve();
            }).catch(error => {
                this.$message.error("网络异常");
                reject(error);
            });
        }
    });
}


//上传 param:{md5:"",file,progress:func(percent){},success:func(){},error:func(){}}
Vue.prototype.$$uploadFileFastDfs = function (param) {
    const _that = this;
    const promise = new Promise((resolve, reject) => {
        let formData = new FormData();
        formData.append("userId", upLoadParams.userId);
        formData.append("moduleName", upLoadParams.moduleName);
        formData.append("md5", param.md5);
        formData.append("file", param.file);
        formData.append("isToPdf", true);
        _that
            .$axios({
                method: "post",
                url: uploadUrl.uploadDfs,
                data: formData,
                headers: {
                    "Content-type": "multipart/form-data"
                },
                onUploadProgress: progressEvent => {
                    let percent = ((progressEvent.loaded / progressEvent.total) * 100) | 0;
                    param.progress && param.progress(percent);
                }
            })
            .then(function (res) {
                resolve(res);
            })
            .catch(function (error) {
                reject(error);
            });
    });
    return promise;
};

Vue.prototype.$$updateAnyoneDownload = function (url) {
    const that = this;
    const promise = new Promise((resolve, reject) => {
        let that = this;
        this.$axios({
                url: this.$api.upload.updateAnyoneDownload,
                method: "post",
                data: {
                    md5Path: url
                }
            })
            .then(function (res) {
                resolve(res);
            })
            .catch(err => {
                reject(err);
            });
    });
    return promise;
};


// 获取md5
Vue.prototype.$$md5ByFile = async function (param) {
    const promise = new Promise((resolve, reject) => {
        let reader = new FileReader();
        console.log(SparkMD5);
        let spark = new SparkMD5.ArrayBuffer();
        reader.onload = function (e) {
            spark.append(e.target.result);
            let md5 = spark.end();
            resolve({
                md5: md5
            });
        };
        reader.onerror = function () {
            reject({
                msg: "file too large"
            });
        };
        let file = param.file.size > 1024 * 1024 * 15 ? param.file.slice(0, 1024 * 1024 * 15) : param.file;
        reader.readAsArrayBuffer(file);
    });
    return promise;
};


//md5校验 param:{file,upLoadParams:{userId,moduleName}}
Vue.prototype.$$md5CheckByFile = function (param) {
    //uploadUrl.md5Check = store.state.fileServiceUrl + $api.upload.md5CheckUpload;
    const promise = new Promise((resolve, reject) => {
        this.$axios({
                // method: "get",
                method: "post",
                url: $api.upload.md5CheckForFrontEnd,
                withCredentials: true,
                data: {
                    md5: param.md5,
                    fileSize: param.file.size,
                    fileSrcName: param.file.name,
                }
                // method: "get",
                // url: $api.upload.md5CheckForFrontEnd,
                // withCredentials: true,
                // params: {
                //     md5: param.md5,
                //     fileSize: param.file.size
                //     userId: upLoadParams.userId,
                //     moduleName: upLoadParams.moduleName,
                //     fileSrcName: param.file.name,
                //     srcSystem: "OA_GT_001",
                //     isTemp: "0",
                //     isPublic: "1",
                //     noSsoUpload: "1",
                //     anyoneDownload: "1"
                // }
            })
            .then(function (res) {
                resolve(res);
            })
            .catch(function (error) {
                reject(error);
            });
    });
    return promise;
};


//上传 param:{md5:"",file,progress:func(percent){},success:func(){},error:func(){}}
Vue.prototype.$$uploadFile = function (param) {
    uploadUrl.uploadDfs = this.$api.common.uploadNew;
    // uploadUrl.uploadDfs = this.$api.upload.uploadDfs;
    const _that = this;
    const promise = new Promise((resolve, reject) => {
        let formData = new FormData();
        formData.append("userId", upLoadParams.userId);
        formData.append("moduleName", upLoadParams.moduleName);
        formData.append("md5", param.md5);
        formData.append("file", param.file);
        formData.append("fileSize", param.file.size);
        formData.append("isTemp", "0");
        formData.append("isPublic", "1");
        formData.append("srcSystem", "OA_GT_001"); //自己服务对应的src
        formData.append("noSsoUpload", "1"); //不需要校验sso
        formData.append("anyoneDownload", "1"); //任何人都可以下载
        formData.append("uploadFileType", param.uploadFileType ? param.uploadFileType : '1');
        //部门共享文件上传时传2，其他默认1或不传
        _that
            .$axios({
                method: "post",
                url: uploadUrl.uploadDfs,
                data: formData,
                withCredentials: true,
                headers: {
                    "Content-type": "multipart/form-data"
                },
                onUploadProgress: progressEvent => {
                    let percent = ((progressEvent.loaded / progressEvent.total) * 100) | 0;
                    param.progress && param.progress(percent);
                }
            })
            .then(function (res) {
                resolve(res);
            })
            .catch(function (error) {
                reject(error);
            });
    });
    return promise;
};